/*
Created		07/11/2006
Modified		11/07/2007
Project		Spagic
Model		MetaDB 
Company		Engineering
Author		Spagic Team
Version		1.0
Database		mySQL 5 
*/


Create table instance_sa (
	id_instance_sa Bigint(20) NOT NULL AUTO_INCREMENT,
	id_assembly Bigint NOT NULL,
	startdate Datetime NOT NULL,
	enddate Datetime NOT NULL,
	state Int(11) NOT NULL,
	id_correlation Varchar(100) NOT NULL,
	id_iter Bigint,
 Primary Key (id_instance_sa)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table journal_instance_service (
	id_journal Bigint(20) NOT NULL AUTO_INCREMENT,
	id_endpoint_source Bigint NOT NULL,
	id_endpoint_target Bigint NOT NULL,
	id_instance_sa Bigint(20) NOT NULL,
	id_msg_exchange Varchar(100) NOT NULL,
	exchange_start Timestamp NOT NULL,
	exchange_inter_1 Timestamp,
	exchange_inter_2 Timestamp,
	exchange_end Timestamp,
	id_ext_process_instance Varchar(45),
	id_state Int NOT NULL,
	message_exchange Blob,
 Primary Key (id_journal)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table log_journal (
	id_log Bigint(20) NOT NULL AUTO_INCREMENT,
	id_state Int NOT NULL,
	id_journal Bigint NOT NULL,
	log Text NOT NULL,
	datelog Datetime NOT NULL,
 Primary Key (id_log)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table property (
	id_property Bigint(20) NOT NULL AUTO_INCREMENT,
	code Varchar(45) NOT NULL,
	value Varchar(2000) NOT NULL,
 Primary Key (id_property)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table property_assembly (
	id_property Bigint(20) NOT NULL,
	id_assembly Bigint NOT NULL,
 Primary Key (id_property,id_assembly)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table service_assembly (
	id_assembly Bigint(20) NOT NULL AUTO_INCREMENT,
	sa_version Bigint NOT NULL,
	name Varchar(200) NOT NULL,
	description Varchar(200),
	id_ts Bigint(20) NOT NULL,
	uddi_org Varchar(200),
	uddi_name Varchar(200),
	startdate Datetime NOT NULL,
	enddate Datetime,
	state Int(10) UNSIGNED NOT NULL,
 Primary Key (id_assembly)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table endpoint (
	id_endpoint Bigint NOT NULL AUTO_INCREMENT,
	namespace Varchar(200) NOT NULL,
	name Varchar(200) NOT NULL,
	description Varchar(200),
	is_start Bool NOT NULL,
	is_end Bool NOT NULL,
	id_assembly Bigint NOT NULL,
	sa_version Bigint NOT NULL,
	id_ts Bigint NOT NULL,
	component_name Varchar(200),
	component_description Varchar(200),
 Primary Key (id_endpoint)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table type_service (
	id_ts Bigint(20) NOT NULL AUTO_INCREMENT,
	value Varchar(45) NOT NULL,
 Primary Key (id_ts)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table property_endpoint (
	id_endpoint Bigint NOT NULL,
	id_property Bigint NOT NULL,
 Primary Key (id_endpoint,id_property)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table mep_state (
	id_state Int NOT NULL,
	state_value Varchar(100),
	Index AI_id_state (id_state),
 Primary Key (id_state)) ENGINE = InnoDB;

Create table sa_svg (
	svg_diag Text,
	id_assembly Bigint NOT NULL,
 Primary Key (id_assembly)) ENGINE = InnoDB;

Create table rule (
	id_rule Bigint NOT NULL AUTO_INCREMENT,
	id_attribute Bigint,
	mep_state Int NOT NULL,
	condition_expr Varchar(300),
	expr Varchar(300) NOT NULL,
	description Varchar(200),
	start_date Date,
	end_date Date,
	id_feeder Bigint,
	rule_type Bigint,
	rule_usage Int NOT NULL,
	Index AI_id_rule (id_rule),
 Primary Key (id_rule)) ENGINE = InnoDB;

Create table relevant_data (
	id_relevant_data Bigint NOT NULL AUTO_INCREMENT,
	id_attribute Bigint NOT NULL,
	id_log Bigint NOT NULL,
	value Varchar(500) NOT NULL,
 Primary Key (id_relevant_data)) ENGINE = InnoDB;

Create table CSCHEME (
	CSCHEME_ID Varchar(50) NOT NULL,
	CSCHEME_NAME Varchar(100) NOT NULL,
	CSCHEME_DESCRIPTION Varchar(200),
 Primary Key (CSCHEME_ID)) ENGINE = InnoDB;

Create table CSCHEME_VALUES (
	CSCHEME_ID Varchar(50) NOT NULL,
	CSCHEME_VALUE Varchar(200) NOT NULL,
 Primary Key (CSCHEME_ID,CSCHEME_VALUE)) ENGINE = InnoDB;

Create table SERVICE_CLASSIFICATION (
	CSCHEME_ID Varchar(50) NOT NULL,
	CSCHEME_VALUE Varchar(200) NOT NULL,
	service_uddi_org Varchar(200) NOT NULL,
	service_uddi_name Varchar(200) NOT NULL,
 Primary Key (CSCHEME_ID,CSCHEME_VALUE,service_uddi_org,service_uddi_name)) ENGINE = InnoDB;

Create table endpoint_rule (
	id_endpoint Bigint NOT NULL,
	id_rule Bigint NOT NULL,
	order_id Int NOT NULL,
 Primary Key (id_endpoint,id_rule)) ENGINE = InnoDB;

Create table catalog (
	id_catalog Bigint NOT NULL AUTO_INCREMENT,
	name Varchar(200) NOT NULL,
	visible Bool,
	mandatory Bool,
 Primary Key (id_catalog)) ENGINE = InnoDB;

Create table attribute (
	id_attribute Bigint NOT NULL AUTO_INCREMENT,
	name Varchar(50) NOT NULL,
	type Int NOT NULL,
 Primary Key (id_attribute)) ENGINE = InnoDB;

Create table external_data_feeder (
	id_feeder Bigint NOT NULL AUTO_INCREMENT,
	feeder_type Varchar(20) NOT NULL,
	additional_info Varchar(200) NOT NULL,
 Primary Key (id_feeder)) ENGINE = InnoDB;

Create table sa_flow (
	id_endpoint_source Bigint NOT NULL,
	id_endpoint_target Bigint NOT NULL,
	id_assembly Bigint NOT NULL,
 Primary Key (id_endpoint_source,id_endpoint_target)) ENGINE = InnoDB;

Create table iter_type (
	id_iter_type Bigint NOT NULL AUTO_INCREMENT,
	id_rule_det_iter_type Bigint,
	name Varchar(200) NOT NULL,
	description Varchar(200) NOT NULL,
	Index AI_id_iter_type (id_iter_type),
 Primary Key (id_iter_type)) ENGINE = InnoDB;

Create table instance_iter (
	id_iter Bigint NOT NULL AUTO_INCREMENT,
	id_iter_type Bigint NOT NULL,
	unique_iter_instance_key Varchar(1000) NOT NULL,
 Primary Key (id_iter)) ENGINE = InnoDB;

Create table iter_type_service_assembly (
	id_assembly Bigint NOT NULL,
	order_criteria Int NOT NULL,
	id_iter_type Bigint NOT NULL,
 Primary Key (id_assembly,id_iter_type)) ENGINE = InnoDB;

Create table relevant_data_instance_sa (
	id_instance_sa Bigint NOT NULL,
	id_relevant_data Bigint NOT NULL,
 Primary Key (id_instance_sa,id_relevant_data)) ENGINE = InnoDB;

Create table xml_namespace (
	id_namespace Bigint NOT NULL AUTO_INCREMENT,
	prefix Varchar(50) NOT NULL,
	value Varchar(200) NOT NULL,
	Index AI_id_namespace (id_namespace),
 Primary Key (id_namespace)) ENGINE = InnoDB;

Create table attribute_iter (
	id_attribute Bigint NOT NULL,
	id_iter_type Bigint NOT NULL,
 Primary Key (id_attribute,id_iter_type)) ENGINE = InnoDB;

Create table attribute_catalog (
	id_attribute Bigint NOT NULL,
	id_catalog Bigint NOT NULL,
	visible Bool,
	order_criteria Int,
 Primary Key (id_attribute,id_catalog)) ENGINE = InnoDB;


Create Index fk_p_sa Using BTREE ON instance_sa (id_assembly);
Create Index idx_correlation_id ON instance_sa (id_correlation);
Create Index fk_jip_p Using BTREE ON journal_instance_service (id_instance_sa);
Create Index fk_sa_ts Using BTREE ON service_assembly (id_ts);


Alter table journal_instance_service add Foreign Key (id_instance_sa) references instance_sa (id_instance_sa) on delete  restrict on update  restrict;
Alter table relevant_data_instance_sa add Foreign Key (id_instance_sa) references instance_sa (id_instance_sa) on delete  restrict on update  restrict;
Alter table log_journal add Foreign Key (id_journal) references journal_instance_service (id_journal) on delete  restrict on update  restrict;
Alter table relevant_data add Foreign Key (id_log) references log_journal (id_log) on delete  restrict on update  restrict;
Alter table property_assembly add Foreign Key (id_property) references property (id_property) on delete  restrict on update  restrict;
Alter table property_endpoint add Foreign Key (id_property) references property (id_property) on delete  restrict on update  restrict;
Alter table instance_sa add Foreign Key (id_assembly) references service_assembly (id_assembly) on delete  restrict on update  restrict;
Alter table property_assembly add Foreign Key (id_assembly) references service_assembly (id_assembly) on delete  restrict on update  restrict;
Alter table endpoint add Foreign Key (id_assembly) references service_assembly (id_assembly) on delete  restrict on update  restrict;
Alter table sa_svg add Foreign Key (id_assembly) references service_assembly (id_assembly) on delete  restrict on update  restrict;
Alter table sa_flow add Foreign Key (id_assembly) references service_assembly (id_assembly) on delete  restrict on update  restrict;
Alter table iter_type_service_assembly add Foreign Key (id_assembly) references service_assembly (id_assembly) on delete  restrict on update  restrict;
Alter table journal_instance_service add Foreign Key (id_endpoint_source) references endpoint (id_endpoint) on delete  restrict on update  restrict;
Alter table property_endpoint add Foreign Key (id_endpoint) references endpoint (id_endpoint) on delete  restrict on update  restrict;
Alter table journal_instance_service add Foreign Key (id_endpoint_target) references endpoint (id_endpoint) on delete  restrict on update  restrict;
Alter table endpoint_rule add Foreign Key (id_endpoint) references endpoint (id_endpoint) on delete  restrict on update  restrict;
Alter table sa_flow add Foreign Key (id_endpoint_source) references endpoint (id_endpoint) on delete  restrict on update  restrict;
Alter table sa_flow add Foreign Key (id_endpoint_target) references endpoint (id_endpoint) on delete  restrict on update  restrict;
Alter table service_assembly add Foreign Key (id_ts) references type_service (id_ts) on delete  restrict on update  restrict;
Alter table endpoint add Foreign Key (id_ts) references type_service (id_ts) on delete  restrict on update  restrict;
Alter table journal_instance_service add Foreign Key (id_state) references mep_state (id_state) on delete  restrict on update  restrict;
Alter table log_journal add Foreign Key (id_state) references mep_state (id_state) on delete  restrict on update  restrict;
Alter table endpoint_rule add Foreign Key (id_rule) references rule (id_rule) on delete  restrict on update  restrict;
Alter table iter_type add Foreign Key (id_rule_det_iter_type) references rule (id_rule) on delete  restrict on update  restrict;
Alter table relevant_data_instance_sa add Foreign Key (id_relevant_data) references relevant_data (id_relevant_data) on delete  restrict on update  restrict;
Alter table CSCHEME_VALUES add Foreign Key (CSCHEME_ID) references CSCHEME (CSCHEME_ID) on delete  restrict on update  restrict;
Alter table SERVICE_CLASSIFICATION add Foreign Key (CSCHEME_ID,CSCHEME_VALUE) references CSCHEME_VALUES (CSCHEME_ID,CSCHEME_VALUE) on delete  restrict on update  restrict;
Alter table attribute_catalog add Foreign Key (id_catalog) references catalog (id_catalog) on delete  restrict on update  restrict;
Alter table relevant_data add Foreign Key (id_attribute) references attribute (id_attribute) on delete  restrict on update  restrict;
Alter table rule add Foreign Key (id_attribute) references attribute (id_attribute) on delete  restrict on update  restrict;
Alter table attribute_iter add Foreign Key (id_attribute) references attribute (id_attribute) on delete  restrict on update  restrict;
Alter table attribute_catalog add Foreign Key (id_attribute) references attribute (id_attribute) on delete  restrict on update  restrict;
Alter table rule add Foreign Key (id_feeder) references external_data_feeder (id_feeder) on delete  restrict on update  restrict;
Alter table instance_iter add Foreign Key (id_iter_type) references iter_type (id_iter_type) on delete  restrict on update  restrict;
Alter table iter_type_service_assembly add Foreign Key (id_iter_type) references iter_type (id_iter_type) on delete  restrict on update  restrict;
Alter table attribute_iter add Foreign Key (id_iter_type) references iter_type (id_iter_type) on delete  restrict on update  restrict;
Alter table instance_sa add Foreign Key (id_iter) references instance_iter (id_iter) on delete  restrict on update  restrict;


