/*
Created		07/11/2006
Modified		11/07/2007
Project		Spagic
Model		MetaDB 
Company		Engineering
Author		Spagic Team
Version		1.0
Database		Oracle 9i 
*/


Drop index fk_sa_ts
;
Drop index fk_jip_p
;
Drop index fk_p_sa
;
Drop index idx_correlation_id
;


Drop table attribute_catalog
;
Drop table attribute_iter
;
Drop table xml_namespace
;



Drop table iter_type_service_assembly
;
Drop table relevant_data_instance_sa
;
Drop table relevant_data
;
Drop table log_journal
;
Drop table journal_instance_service
;
Drop table instance_sa
;
Drop table instance_iter
;
Drop table catalog
;
Drop table iter_type
;
Drop table endpoint_rule
;
Drop table rule
;
Drop table attribute
;

Drop table external_data_feeder
;


Drop table sa_flow
;

Drop table SERVICE_CLASSIFICATION
;
Drop table CSCHEME_VALUES
;
Drop table CSCHEME
;

Drop table sa_svg
;
Drop table mep_state
;
Drop table property_endpoint
;
Drop table endpoint
;
Drop table property_assembly
;
Drop table service_assembly
;
Drop table type_service
;
Drop table property
;


DROP SEQUENCE seq_instance_sa;

DROP SEQUENCE seq_journal_instance_service;

DROP SEQUENCE seq_log_journal;

DROP SEQUENCE seq_property;

DROP SEQUENCE seq_property_assembly;

DROP SEQUENCE seq_service_assembly;

DROP SEQUENCE seq_endpoint;

DROP SEQUENCE seq_type_service;

DROP SEQUENCE seq_property_endpoint;

DROP SEQUENCE seq_mep_state;

DROP SEQUENCE seq_sa_svg;

DROP SEQUENCE seq_rule;

DROP SEQUENCE seq_relevant_data;

DROP SEQUENCE seq_CSCHEME;

DROP SEQUENCE seq_CSCHEME_VALUES;

DROP SEQUENCE seq_SERVICE_CLASSIFICATION;

DROP SEQUENCE seq_endpoint_rule;

DROP SEQUENCE seq_catalog;

DROP SEQUENCE seq_attribute;

DROP SEQUENCE seq_external_data_feeder;

DROP SEQUENCE seq_sa_flow;

DROP SEQUENCE seq_iter_type;

DROP SEQUENCE seq_instance_iter;

DROP SEQUENCE seq_iter_type_service_assembly;

DROP SEQUENCE seq_relevant_data_instance_sa;

DROP SEQUENCE seq_xml_namespace;

DROP SEQUENCE seq_attribute_iter;

DROP SEQUENCE seq_attribute_catalog;

-- Create Types section


-- Create Tables section


Create table instance_sa (
	id_instance_sa Integer NOT NULL ,
	id_assembly Integer NOT NULL ,
	startdate Timestamp(0) NOT NULL ,
	enddate Timestamp(0) NOT NULL ,
	state Integer NOT NULL ,
	id_correlation Varchar2 (100) NOT NULL ,
	id_iter Integer,
primary key (id_instance_sa) 
) 
;

Create table journal_instance_service (
	id_journal Integer NOT NULL ,
	id_endpoint_source Integer NOT NULL ,
	id_endpoint_target Integer NOT NULL ,
	id_instance_sa Integer NOT NULL ,
	id_msg_exchange Varchar2 (100) NOT NULL ,
	exchange_start Timestamp(0) NOT NULL ,
	exchange_inter_1 Timestamp(9),
	exchange_inter_2 Timestamp(9),
	exchange_end Timestamp(0),
	id_ext_process_instance Varchar2 (45),
	id_state Integer NOT NULL ,
	message_exchange Blob,
primary key (id_journal) 
) 
;

Create table log_journal (
	id_log Integer NOT NULL ,
	id_state Integer NOT NULL ,
	id_journal Integer NOT NULL ,
	log Clob NOT NULL ,
	datelog Timestamp(0) NOT NULL ,
primary key (id_log) 
) 
;

Create table property (
	id_property Integer NOT NULL ,
	code Varchar2 (45) NOT NULL ,
	value Varchar2 (2000) NOT NULL ,
primary key (id_property) 
) 
;

Create table property_assembly (
	id_property Integer NOT NULL ,
	id_assembly Integer NOT NULL ,
primary key (id_property,id_assembly) 
) 
;

Create table service_assembly (
	id_assembly Integer NOT NULL ,
	sa_version Integer NOT NULL ,
	name Varchar2 (200) NOT NULL ,
	description Varchar2 (200),
	id_ts Integer NOT NULL ,
	uddi_org Varchar2 (200),
	uddi_name Varchar2 (200),
	startdate Timestamp(9) NOT NULL ,
	enddate Timestamp(9),
	state Integer NOT NULL ,
primary key (id_assembly) 
) 
;

Create table endpoint (
	id_endpoint Integer NOT NULL ,
	namespace Varchar2 (200) NOT NULL ,
	name Varchar2 (200) NOT NULL ,
	description Varchar2 (200),
	is_start Char (1) NOT NULL ,
	is_end Char (1) NOT NULL ,
	id_assembly Integer NOT NULL ,
	sa_version Integer NOT NULL ,
	id_ts Integer NOT NULL ,
	component_name Varchar2 (200),
	component_description Varchar2 (200),
primary key (id_endpoint) 
) 
;

Create table type_service (
	id_ts Integer NOT NULL ,
	value Varchar2 (45) NOT NULL ,
primary key (id_ts) 
) 
;

Create table property_endpoint (
	id_endpoint Integer NOT NULL ,
	id_property Integer NOT NULL ,
primary key (id_endpoint,id_property) 
) 
;

Create table mep_state (
	id_state Integer NOT NULL ,
	state_value Varchar2 (100),
primary key (id_state) 
) 
;

Create table sa_svg (
	svg_diag Clob,
	id_assembly Integer NOT NULL ,
primary key (id_assembly) 
) 
;

Create table rule (
	id_rule Integer NOT NULL ,
	id_attribute Integer,
	mep_state Integer NOT NULL ,
	condition_expr Varchar2 (300),
	expr Varchar2 (300) NOT NULL ,
	description Varchar2 (200),
	start_date Date,
	end_date Date,
	id_feeder Integer,
	rule_type Integer,
	rule_usage Integer NOT NULL ,
primary key (id_rule) 
) 
;

Create table relevant_data (
	id_relevant_data Integer NOT NULL ,
	id_attribute Integer NOT NULL ,
	id_log Integer NOT NULL ,
	value Varchar2 (500) NOT NULL ,
primary key (id_relevant_data) 
) 
;

Create table CSCHEME (
	CSCHEME_ID Varchar2 (50) NOT NULL ,
	CSCHEME_NAME Varchar2 (100) NOT NULL ,
	CSCHEME_DESCRIPTION Varchar2 (200),
primary key (CSCHEME_ID) 
) 
;

Create table CSCHEME_VALUES (
	CSCHEME_ID Varchar2 (50) NOT NULL ,
	CSCHEME_VALUE Varchar2 (200) NOT NULL ,
primary key (CSCHEME_ID,CSCHEME_VALUE) 
) 
;

Create table SERVICE_CLASSIFICATION (
	CSCHEME_ID Varchar2 (50) NOT NULL ,
	CSCHEME_VALUE Varchar2 (200) NOT NULL ,
	service_uddi_org Varchar2 (200) NOT NULL ,
	service_uddi_name Varchar2 (200) NOT NULL ,
primary key (CSCHEME_ID,CSCHEME_VALUE,service_uddi_org,service_uddi_name) 
) 
;

Create table endpoint_rule (
	id_endpoint Integer NOT NULL ,
	id_rule Integer NOT NULL ,
	order_id Integer NOT NULL ,
primary key (id_endpoint,id_rule) 
) 
;

Create table catalog (
	id_catalog Integer NOT NULL ,
	name Varchar2 (200) NOT NULL ,
	visible Char (1),
	mandatory Char (1),
primary key (id_catalog) 
) 
;

Create table attribute (
	id_attribute Integer NOT NULL ,
	name Varchar2 (50) NOT NULL ,
	type Integer NOT NULL ,
primary key (id_attribute) 
) 
;

Create table external_data_feeder (
	id_feeder Integer NOT NULL ,
	feeder_type Varchar2 (20) NOT NULL ,
	additional_info Varchar2 (200) NOT NULL ,
primary key (id_feeder) 
) 
;

Create table sa_flow (
	id_endpoint_source Integer NOT NULL ,
	id_endpoint_target Integer NOT NULL ,
	id_assembly Integer NOT NULL ,
primary key (id_endpoint_source,id_endpoint_target) 
) 
;

Create table iter_type (
	id_iter_type Integer NOT NULL ,
	id_rule_det_iter_type Integer,
	name Varchar2 (200) NOT NULL ,
	description Varchar2 (200) NOT NULL ,
primary key (id_iter_type) 
) 
;

Create table instance_iter (
	id_iter Integer NOT NULL ,
	id_iter_type Integer NOT NULL ,
	unique_iter_instance_key Varchar2 (1000) NOT NULL ,
primary key (id_iter) 
) 
;

Create table iter_type_service_assembly (
	id_assembly Integer NOT NULL ,
	order_criteria Integer NOT NULL ,
	id_iter_type Integer NOT NULL ,
primary key (id_assembly,id_iter_type) 
) 
;

Create table relevant_data_instance_sa (
	id_instance_sa Integer NOT NULL ,
	id_relevant_data Integer NOT NULL ,
primary key (id_instance_sa,id_relevant_data) 
) 
;

Create table xml_namespace (
	id_namespace Integer NOT NULL ,
	prefix Varchar2 (50) NOT NULL ,
	value Varchar2 (200) NOT NULL ,
primary key (id_namespace) 
) 
;

Create table attribute_iter (
	id_attribute Integer NOT NULL ,
	id_iter_type Integer NOT NULL ,
primary key (id_attribute,id_iter_type) 
) 
;

Create table attribute_catalog (
	id_attribute Integer NOT NULL ,
	id_catalog Integer NOT NULL ,
	visible Char (1),
	order_criteria Integer,
primary key (id_attribute,id_catalog) 
) 
;


-- Create Alternate keys section


-- Create Indexes section

Create Index fk_p_sa ON instance_sa (id_assembly) 
;
Create Index idx_correlation_id ON instance_sa (id_correlation) 
;
Create Index fk_jip_p ON journal_instance_service (id_instance_sa) 
;
Create Index fk_sa_ts ON service_assembly (id_ts) 
;


-- Create Foreign keys section

Alter table journal_instance_service add  foreign key (id_instance_sa) references instance_sa (id_instance_sa) 
;

Alter table relevant_data_instance_sa add  foreign key (id_instance_sa) references instance_sa (id_instance_sa) 
;

Alter table log_journal add  foreign key (id_journal) references journal_instance_service (id_journal) 
;

Alter table relevant_data add  foreign key (id_log) references log_journal (id_log) 
;

Alter table property_assembly add  foreign key (id_property) references property (id_property) 
;

Alter table property_endpoint add  foreign key (id_property) references property (id_property) 
;

Alter table instance_sa add  foreign key (id_assembly) references service_assembly (id_assembly) 
;

Alter table property_assembly add  foreign key (id_assembly) references service_assembly (id_assembly) 
;

Alter table endpoint add  foreign key (id_assembly) references service_assembly (id_assembly) 
;

Alter table sa_svg add  foreign key (id_assembly) references service_assembly (id_assembly) 
;

Alter table sa_flow add  foreign key (id_assembly) references service_assembly (id_assembly) 
;

Alter table iter_type_service_assembly add  foreign key (id_assembly) references service_assembly (id_assembly) 
;

Alter table journal_instance_service add  foreign key (id_endpoint_source) references endpoint (id_endpoint) 
;

Alter table property_endpoint add  foreign key (id_endpoint) references endpoint (id_endpoint) 
;

Alter table journal_instance_service add  foreign key (id_endpoint_target) references endpoint (id_endpoint) 
;

Alter table endpoint_rule add  foreign key (id_endpoint) references endpoint (id_endpoint) 
;

Alter table sa_flow add  foreign key (id_endpoint_source) references endpoint (id_endpoint) 
;

Alter table sa_flow add  foreign key (id_endpoint_target) references endpoint (id_endpoint) 
;

Alter table service_assembly add  foreign key (id_ts) references type_service (id_ts) 
;

Alter table endpoint add  foreign key (id_ts) references type_service (id_ts) 
;

Alter table journal_instance_service add  foreign key (id_state) references mep_state (id_state) 
;

Alter table log_journal add  foreign key (id_state) references mep_state (id_state) 
;

Alter table endpoint_rule add  foreign key (id_rule) references rule (id_rule) 
;

Alter table iter_type add  foreign key (id_rule_det_iter_type) references rule (id_rule) 
;

Alter table relevant_data_instance_sa add  foreign key (id_relevant_data) references relevant_data (id_relevant_data) 
;

Alter table CSCHEME_VALUES add  foreign key (CSCHEME_ID) references CSCHEME (CSCHEME_ID) 
;

Alter table SERVICE_CLASSIFICATION add  foreign key (CSCHEME_ID,CSCHEME_VALUE) references CSCHEME_VALUES (CSCHEME_ID,CSCHEME_VALUE) 
;

Alter table attribute_catalog add  foreign key (id_catalog) references catalog (id_catalog) 
;

Alter table relevant_data add  foreign key (id_attribute) references attribute (id_attribute) 
;

Alter table rule add  foreign key (id_attribute) references attribute (id_attribute) 
;

Alter table attribute_iter add  foreign key (id_attribute) references attribute (id_attribute) 
;

Alter table attribute_catalog add  foreign key (id_attribute) references attribute (id_attribute) 
;

Alter table rule add  foreign key (id_feeder) references external_data_feeder (id_feeder) 
;

Alter table instance_iter add  foreign key (id_iter_type) references iter_type (id_iter_type) 
;

Alter table iter_type_service_assembly add  foreign key (id_iter_type) references iter_type (id_iter_type) 
;

Alter table attribute_iter add  foreign key (id_iter_type) references iter_type (id_iter_type) 
;

Alter table instance_sa add  foreign key (id_iter) references instance_iter (id_iter) 
;


-- Create Object Tables section


-- Create XMLType Tables section


-- Create Procedures section


-- Create Functions section


-- Create Views section


-- Create Sequences section
CREATE SEQUENCE seq_instance_sa;

CREATE SEQUENCE seq_journal_instance_service;

CREATE SEQUENCE seq_log_journal;

CREATE SEQUENCE seq_property;

CREATE SEQUENCE seq_property_assembly;

CREATE SEQUENCE seq_service_assembly;

CREATE SEQUENCE seq_endpoint;

CREATE SEQUENCE seq_type_service;

CREATE SEQUENCE seq_property_endpoint;

CREATE SEQUENCE seq_mep_state;

CREATE SEQUENCE seq_sa_svg;

CREATE SEQUENCE seq_rule;

CREATE SEQUENCE seq_relevant_data;

CREATE SEQUENCE seq_CSCHEME;

CREATE SEQUENCE seq_CSCHEME_VALUES;

CREATE SEQUENCE seq_SERVICE_CLASSIFICATION;

CREATE SEQUENCE seq_endpoint_rule;

CREATE SEQUENCE seq_catalog;

CREATE SEQUENCE seq_attribute;

CREATE SEQUENCE seq_external_data_feeder;

CREATE SEQUENCE seq_sa_flow;

CREATE SEQUENCE seq_iter_type;

CREATE SEQUENCE seq_instance_iter;

CREATE SEQUENCE seq_iter_type_service_assembly;

CREATE SEQUENCE seq_relevant_data_instance_sa;

CREATE SEQUENCE seq_xml_namespace;

CREATE SEQUENCE seq_attribute_iter;

CREATE SEQUENCE seq_attribute_catalog;


-- Create Triggers from referential integrity section


-- Create user Triggers section


-- Create Packages section


-- Create Synonyms section


-- Create Table comments section

Comment on table instance_sa is 'Tabella di auditing.
Per ciascuna istanza di processo esiste una riga in questa tabella.'
;
Comment on table journal_instance_service is 'Tabella di auditing.
Per ciascun endpoint GIA'' UTILIZZATO nel service assembly esiste una riga in questa tabella.'
;
Comment on table log_journal is 'Tabella di auditing.
Nel caso sia configurato il tracciamento dei messaggi, questa tabella viene utilizzata a tal scopo.'
;
Comment on table service_assembly is 'Tabella di configurazione.
Censisce tutti i PROCESSI.'
;
Comment on table endpoint is 'Tabella di configurazione.
Per ciascun processo (service_assembly) censisce gli ENDPOINT associati a ciascun componente (service).
Un componente utilizzato in processi diversi genera Endpoint diversi.

Se un componente viene utilizzato in 10 processi, ad esempio, sar� censito come segue nel database:
   - 1 riga in "service" per censire il componente
   - 10 righe in "service_assembly" per censire i 10 processi
   - 10 righe (ALMENO) in "endpoint" per censire i 10 utilizzi del componente nei 10 processi

L''utilizzo di un componente in un processo pu� generare pi� Endpoint: questo � vero per i Binding Component di avvio dei processi (vedi concetto di external e internal endpoint).'
;
Comment on table type_service is 'Tabella di configurazione.
Censice i TIPI DI COMPONENTE, ad esempio "Binding Component" o "Service Engine".'
;
Comment on table mep_state is 'Possibili stati per i 4 MEP supportati

MEP In-Only
  - Active
  - Done
  - Fault.

MEP Robust In-Only
  - Active
  - Done
  - Fault

MEP In-Out
  - Active
  - Out
  - Fault

MEP In Optional-Out
  - Active
  - Out
  - Fault
  - Done'
;
Comment on table endpoint_rule is 'Tabella di configurazione.
Tabella associativa tra gli ENDPOINT (endpoint) e le REGOLE (rules): contiene le regole da utilizzarsi per ciascun processo.
Tale tabella viene valorizzata alla definizione del processo, con le regole preconfigurate in "service_rules".'
;
Comment on table catalog is 'Tabella di configurazione (Metadati).
Classificazione degli attributi secondo raggruppamenti logici.'
;
Comment on table attribute is 'Tabella di configurazione (Metadati).
Contiene tutte le tipologie di attributi corrispondenti ai dati rilevanti.'
;
Comment on table sa_flow is 'Tabella di configurazione.
A ciascuna transizione nel grafo di descrizione del processo, corrisponde una riga di questa tabella.'
;
Comment on table iter_type is 'Tabella di configurazione.
Censisce le tipologie di iter disponibili.'
;
Comment on table instance_iter is 'Tabella di auditing.
Censisce tutte le istanze di iter.'
;

-- Create Attribute comments section

Comment on column instance_sa.state is 'Stato dell''istanza: 
- Attivo
- Terminato
- Terminato con errore'
;
Comment on column instance_sa.id_correlation is 'Correlation Id necessario a tracciare il flusso degli Exchange in ServiceMix. Non � la chiave primaria in quanto non � assicurato che ServiceMix generi identificatori sempre diverso, ad esempio in caso di riavvio del server.'
;
Comment on column journal_instance_service.id_instance_sa is 'Riferimento al Service Assembly'
;
Comment on column journal_instance_service.id_msg_exchange is 'Identificatore del message exchange'
;
Comment on column journal_instance_service.exchange_start is 'Istante di invio dell''exchange con stato Active.'
;
Comment on column journal_instance_service.exchange_inter_1 is 'MEP  Robust In-Only
Istante di invio dell''exchange Done o Fault.

MEP In-Out
Istante di invio dell''exchange Out o Fault.

MEP In Optional-Out
Istante di invio dell''exchange Out o Fault o Done.
'
;
Comment on column journal_instance_service.exchange_inter_2 is 'MEP In Optional-Out
Istante di invio dell''exchange Fault o Done.
'
;
Comment on column journal_instance_service.exchange_end is 'Istante di invio dell''exchange con stato Done.'
;
Comment on column journal_instance_service.id_ext_process_instance is 'Riferimento all''identificatore del processo esterno, ad esempio un processo BPEL, non tracciabile dal listener.'
;
Comment on column journal_instance_service.id_state is 'Stato corrente del message exchange'
;
Comment on column service_assembly.sa_version is 'Versione del processo.'
;
Comment on column service_assembly.name is 'Nome del processo.'
;
Comment on column service_assembly.description is 'Descrizione del processo.'
;
Comment on column service_assembly.uddi_org is 'Nome dell''organizzazione sotto al quale � censito il processo in UDDI.'
;
Comment on column service_assembly.uddi_name is 'Nome del servizio sotto al quale � censito il processo in UDDI.'
;
Comment on column service_assembly.startdate is 'Data di inizio validit� del processo.'
;
Comment on column service_assembly.enddate is 'Data di fine validit� del processo.'
;
Comment on column service_assembly.state is 'Indica lo stato del processo (ATTIVO, NON_ATTIVO, etc).'
;
Comment on column rule.id_attribute is 'Tipo di attributo che questa regola genera'
;
Comment on column rule.mep_state is 'Indica a quale tipo di messaggio nel MEP va applicata la regola.
Valori previsti:
- 0: IN (si applica a tutti i MEP)
- 1: OUT (si applica ai MEP IN-OUT e IN-OPTIONAL-OUT)
- 2: IN-OUT
'
;
Comment on column rule.condition_expr is 'Precondizione XPath'
;
Comment on column rule.expr is 'Espressione XPath'
;
Comment on column rule.start_date is 'Data inizio applicabilit� regola'
;
Comment on column rule.end_date is 'Data fine applicabilit� regola'
;
Comment on column rule.rule_type is 'Tipo di regola: 
1. Espressione XPath
2. Espressione Drools
3. Espressione Groovy
'
;
Comment on column rule.rule_usage is 'Scopo della regola.
Valori possibili:
- 0: estrazione dati
- 1: determinazione tipo iter'
;
Comment on column xml_namespace.prefix is 'The namespace alias
'
;


